diff --git a/drivers/net/sfc/base/ef10_impl.h b/drivers/net/sfc/base/ef10_impl.h
index 0530f62baa..1f17fc2f69 100644
--- a/drivers/net/sfc/base/ef10_impl.h
+++ b/drivers/net/sfc/base/ef10_impl.h
@@ -91,15 +91,15 @@ extern "C" {
 
 /* EV */
 
-	__checkReturn	efx_rc_t
+extern	__checkReturn	efx_rc_t
 ef10_ev_init(
 	__in		efx_nic_t *enp);
 
-			void
+extern			void
 ef10_ev_fini(
 	__in		efx_nic_t *enp);
 
-	__checkReturn	efx_rc_t
+extern	__checkReturn	efx_rc_t
 ef10_ev_qcreate(
 	__in		efx_nic_t *enp,
 	__in		unsigned int index,
@@ -110,85 +110,85 @@ ef10_ev_qcreate(
 	__in		uint32_t flags,
 	__in		efx_evq_t *eep);
 
-			void
+extern			void
 ef10_ev_qdestroy(
 	__in		efx_evq_t *eep);
 
-	__checkReturn	efx_rc_t
+extern	__checkReturn	efx_rc_t
 ef10_ev_qprime(
 	__in		efx_evq_t *eep,
 	__in		unsigned int count);
 
-			void
+extern			void
 ef10_ev_qpost(
 	__in	efx_evq_t *eep,
 	__in	uint16_t data);
 
-	__checkReturn	efx_rc_t
+extern	__checkReturn	efx_rc_t
 ef10_ev_qmoderate(
 	__in		efx_evq_t *eep,
 	__in		unsigned int us);
 
 #if EFSYS_OPT_QSTATS
-			void
+extern			void
 ef10_ev_qstats_update(
 	__in				efx_evq_t *eep,
 	__inout_ecount(EV_NQSTATS)	efsys_stat_t *stat);
 #endif /* EFSYS_OPT_QSTATS */
 
-		void
+extern			void
 ef10_ev_rxlabel_init(
 	__in		efx_evq_t *eep,
 	__in		efx_rxq_t *erp,
 	__in		unsigned int label,
 	__in		efx_rxq_type_t type);
 
-		void
+extern			void
 ef10_ev_rxlabel_fini(
 	__in		efx_evq_t *eep,
 	__in		unsigned int label);
 
 /* INTR */
 
-	__checkReturn	efx_rc_t
+extern	__checkReturn	efx_rc_t
 ef10_intr_init(
 	__in		efx_nic_t *enp,
 	__in		efx_intr_type_t type,
 	__in		efsys_mem_t *esmp);
 
-			void
+extern			void
 ef10_intr_enable(
 	__in		efx_nic_t *enp);
 
-			void
+extern			void
 ef10_intr_disable(
 	__in		efx_nic_t *enp);
 
-			void
+extern			void
 ef10_intr_disable_unlocked(
 	__in		efx_nic_t *enp);
 
-	__checkReturn	efx_rc_t
+extern	__checkReturn	efx_rc_t
 ef10_intr_trigger(
 	__in		efx_nic_t *enp,
 	__in		unsigned int level);
 
-			void
+extern			void
 ef10_intr_status_line(
 	__in		efx_nic_t *enp,
 	__out		boolean_t *fatalp,
 	__out		uint32_t *qmaskp);
 
-			void
+extern			void
 ef10_intr_status_message(
 	__in		efx_nic_t *enp,
 	__in		unsigned int message,
 	__out		boolean_t *fatalp);
 
-			void
+extern			void
 ef10_intr_fatal(
 	__in		efx_nic_t *enp);
-			void
+extern			void
 ef10_intr_fini(
 	__in		efx_nic_t *enp);
 
@@ -1134,25 +1134,25 @@ typedef struct ef10_filter_table_s {
 	uint32_t		eft_encap_filter_count;
 } ef10_filter_table_t;
 
-	__checkReturn	efx_rc_t
+extern	__checkReturn	efx_rc_t
 ef10_filter_init(
 	__in		efx_nic_t *enp);
 
-			void
+extern			void
 ef10_filter_fini(
 	__in		efx_nic_t *enp);
 
-	__checkReturn	efx_rc_t
+extern	__checkReturn	efx_rc_t
 ef10_filter_restore(
 	__in		efx_nic_t *enp);
 
-	__checkReturn	efx_rc_t
+extern	__checkReturn	efx_rc_t
 ef10_filter_add(
 	__in		efx_nic_t *enp,
 	__inout		efx_filter_spec_t *spec,
 	__in		enum efx_filter_replacement_policy_e policy);
 
-	__checkReturn	efx_rc_t
+extern	__checkReturn	efx_rc_t
 ef10_filter_delete(
 	__in		efx_nic_t *enp,
 	__inout		efx_filter_spec_t *spec);
@@ -1394,26 +1394,26 @@ ef10_proxy_auth_privilege_modify(
 	__in		uint32_t add_privileges_mask,
 	__in		uint32_t remove_privileges_mask);
 
-	__checkReturn	efx_rc_t
+extern	__checkReturn	efx_rc_t
 ef10_proxy_auth_set_privilege_mask(
 	__in		efx_nic_t *enp,
 	__in		uint32_t vf_index,
 	__in		uint32_t mask,
 	__in		uint32_t value);
 
-	__checkReturn	efx_rc_t
+extern	__checkReturn	efx_rc_t
 ef10_proxy_auth_complete_request(
 	__in		efx_nic_t *enp,
 	__in		uint32_t fn_index,
 	__in		uint32_t proxy_result,
 	__in		uint32_t handle);
 
-	__checkReturn	efx_rc_t
+extern	__checkReturn	efx_rc_t
 ef10_proxy_auth_exec_cmd(
 	__in		efx_nic_t *enp,
 	__inout		efx_proxy_cmd_params_t *paramsp);
 
-	__checkReturn	efx_rc_t
+extern	__checkReturn	efx_rc_t
 ef10_proxy_auth_get_privilege_mask(
 	__in		efx_nic_t *enp,
 	__in		uint32_t pf_index,
diff --git a/drivers/net/sfc/base/efx.h b/drivers/net/sfc/base/efx.h
index 07cd0bb398..f723ff2540 100644
--- a/drivers/net/sfc/base/efx.h
+++ b/drivers/net/sfc/base/efx.h
@@ -269,7 +269,7 @@ extern	__checkReturn	efx_rc_t
 efx_mcdi_reboot(
 	__in		efx_nic_t *enp);
 
-			void
+extern			void
 efx_mcdi_new_epoch(
 	__in		efx_nic_t *enp);
 
@@ -2346,7 +2346,7 @@ efx_rx_fini(
 	__in		efx_nic_t *enp);
 
 #if EFSYS_OPT_RX_SCATTER
-	__checkReturn	efx_rc_t
+extern	__checkReturn	efx_rc_t
 efx_rx_scatter_enable(
 	__in		efx_nic_t *enp,
 	__in		unsigned int buf_size);
@@ -3244,7 +3244,7 @@ efx_lic_write_key(
 	__in			uint32_t length,
 	__out			uint32_t *lengthp);
 
-	__checkReturn		efx_rc_t
+extern	__checkReturn		efx_rc_t
 efx_lic_delete_key(
 	__in			efx_nic_t *enp,
 	__in_bcount(buffer_size)
@@ -3511,38 +3511,38 @@ efx_proxy_auth_configure(
 	__in		efx_nic_t *enp,
 	__in		efx_proxy_auth_config_t *configp);
 
-	__checkReturn	efx_rc_t
+extern	__checkReturn	efx_rc_t
 efx_proxy_auth_destroy(
 	__in		efx_nic_t *enp,
 	__in		uint32_t handled_privileges);
 
-	__checkReturn	efx_rc_t
+extern	__checkReturn	efx_rc_t
 efx_proxy_auth_complete_request(
 	__in		efx_nic_t *enp,
 	__in		uint32_t fn_index,
 	__in		uint32_t proxy_result,
 	__in		uint32_t handle);
 
-	__checkReturn	efx_rc_t
+extern	__checkReturn	efx_rc_t
 efx_proxy_auth_exec_cmd(
 	__in		efx_nic_t *enp,
 	__inout		efx_proxy_cmd_params_t *paramsp);
 
-	__checkReturn	efx_rc_t
+extern	__checkReturn	efx_rc_t
 efx_proxy_auth_set_privilege_mask(
 	__in		efx_nic_t *enp,
 	__in		uint32_t vf_index,
 	__in		uint32_t mask,
 	__in		uint32_t value);
 
-	__checkReturn	efx_rc_t
+extern	__checkReturn	efx_rc_t
 efx_proxy_auth_privilege_mask_get(
 	__in		efx_nic_t *enp,
 	__in		uint32_t pf_index,
 	__in		uint32_t vf_index,
 	__out		uint32_t *maskp);
 
-	__checkReturn	efx_rc_t
+extern	__checkReturn	efx_rc_t
 efx_proxy_auth_privilege_modify(
 	__in		efx_nic_t *enp,
 	__in		uint32_t pf_index,
diff --git a/drivers/net/sfc/base/efx_impl.h b/drivers/net/sfc/base/efx_impl.h
index c4718dba70..70176760be 100644
--- a/drivers/net/sfc/base/efx_impl.h
+++ b/drivers/net/sfc/base/efx_impl.h
@@ -566,14 +566,14 @@ typedef struct efx_vpd_ops_s {
 
 #if EFSYS_OPT_VPD || EFSYS_OPT_NVRAM
 
-	__checkReturn		efx_rc_t
+extern	__checkReturn		efx_rc_t
 efx_mcdi_nvram_partitions(
 	__in			efx_nic_t *enp,
 	__out_bcount(size)	caddr_t data,
 	__in			size_t size,
 	__out			unsigned int *npartnp);
 
-	__checkReturn		efx_rc_t
+extern	__checkReturn		efx_rc_t
 efx_mcdi_nvram_metadata(
 	__in			efx_nic_t *enp,
 	__in			uint32_t partn,
@@ -582,18 +582,18 @@ efx_mcdi_nvram_metadata(
 	__out_bcount_opt(size)	char *descp,
 	__in			size_t size);
 
-	__checkReturn		efx_rc_t
+extern	__checkReturn		efx_rc_t
 efx_mcdi_nvram_info(
 	__in			efx_nic_t *enp,
 	__in			uint32_t partn,
 	__out			efx_nvram_info_t *eni);
 
-	__checkReturn		efx_rc_t
+extern	__checkReturn		efx_rc_t
 efx_mcdi_nvram_update_start(
 	__in			efx_nic_t *enp,
 	__in			uint32_t partn);
 
-	__checkReturn		efx_rc_t
+extern	__checkReturn		efx_rc_t
 efx_mcdi_nvram_read(
 	__in			efx_nic_t *enp,
 	__in			uint32_t partn,
@@ -602,14 +602,14 @@ efx_mcdi_nvram_read(
 	__in			size_t size,
 	__in			uint32_t mode);
 
-	__checkReturn		efx_rc_t
+extern	__checkReturn		efx_rc_t
 efx_mcdi_nvram_erase(
 	__in			efx_nic_t *enp,
 	__in			uint32_t partn,
 	__in			uint32_t offset,
 	__in			size_t size);
 
-	__checkReturn		efx_rc_t
+extern	__checkReturn		efx_rc_t
 efx_mcdi_nvram_write(
 	__in			efx_nic_t *enp,
 	__in			uint32_t partn,
@@ -620,7 +620,7 @@ efx_mcdi_nvram_write(
 #define	EFX_NVRAM_UPDATE_FLAGS_BACKGROUND	0x00000001
 #define	EFX_NVRAM_UPDATE_FLAGS_POLL		0x00000002
 
-	__checkReturn		efx_rc_t
+extern	__checkReturn		efx_rc_t
 efx_mcdi_nvram_update_finish(
 	__in			efx_nic_t *enp,
 	__in			uint32_t partn,
@@ -630,7 +630,7 @@ efx_mcdi_nvram_update_finish(
 
 #if EFSYS_OPT_DIAG
 
-	__checkReturn		efx_rc_t
+extern	__checkReturn		efx_rc_t
 efx_mcdi_nvram_test(
 	__in			efx_nic_t *enp,
 	__in			uint32_t partn);
diff --git a/drivers/net/sfc/base/mcdi_mon.h b/drivers/net/sfc/base/mcdi_mon.h
index d7fbf07c36..c79f55c35f 100644
--- a/drivers/net/sfc/base/mcdi_mon.h
+++ b/drivers/net/sfc/base/mcdi_mon.h
@@ -17,11 +17,11 @@ extern "C" {
 
 #if EFSYS_OPT_MON_STATS
 
-	__checkReturn	efx_rc_t
+extern	__checkReturn	efx_rc_t
 mcdi_mon_cfg_build(
     __in		efx_nic_t *enp);
 
-			void
+extern			void
 mcdi_mon_cfg_free(
 	__in		efx_nic_t *enp);
 